import java.net.ServerSocket;
import java.net.Socket;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import javax.bluetooth.LocalDevice;
import javax.bluetooth.DataElement;
import javax.bluetooth.DiscoveryAgent;
import javax.bluetooth.ServiceRecord;
import javax.bluetooth.UUID;
import javax.microedition.io.Connector;
import javax.microedition.io.StreamConnection;
import javax.microedition.io.StreamConnectionNotifier;


public class BTServer implements Runnable {
    private static final UUID RFCOMM_UUID = new UUID("F0E0D0C0B0A000908070605040302010", false);
    private static String URL = "btspp://localhost:" + RFCOMM_UUID + ";name=TEST;authorize=false";   //???? false
    private static final int ATTRIBUTE_ID = 0x4321;
    private LocalDevice localDevice;
    private StreamConnectionNotifier notifier;
    private ServiceRecord record;
    private boolean isClosed;
    private Thread Hilo;
    
    public BTServer() {
        Hilo = new Thread(this);
        Hilo.start();	System.out.println("BT Start");
    }
    
    void destroy() {
        isClosed = true;
        if (notifier != null) {
            try { notifier.close();} catch (IOException e) { } // ignore
        }
        try { Hilo.join();} //espera a que el Hilo termine...
        catch (InterruptedException e) {} // ignore
    }
    
    public void run() {
        boolean isBTReady = false;	System.out.println("Run");
        try {
            localDevice = LocalDevice.getLocalDevice();
            localDevice.setDiscoverable(DiscoveryAgent.GIAC);
            System.out.println(localDevice.getBluetoothAddress());
            System.out.println(URL);
            notifier = (StreamConnectionNotifier) Connector.open(URL);
            record = localDevice.getRecord(notifier);
            DataElement base = new DataElement(DataElement.DATSEQ);
            record.setAttributeValue(ATTRIBUTE_ID, base);
            isBTReady = true;
        } catch (Exception  e) {System.err.println("Error: " + e);}
        
        if (!isBTReady) {return; }// no hay bluetooth
        
        
        
        /*  Ingresar Clase VirtualServer*/
        
        
        
        
        while (!isClosed) {
            System.out.println("Esperando conexi�n...");
            StreamConnection conn = null;
            String s = null;
            InputStream in = null;
         
            try {
                conn = notifier.acceptAndOpen();
                in = conn.openInputStream();
                int length = in.read(); // length is 1 byte
                byte[] inData = new byte[length];
                length = 0;
                while (length != inData.length) {
                    int n = in.read(inData, length, inData.length - length);
                    if (n == -1) { throw new IOException("Error Read2");}
                    length += n;
                }
                s = new String(inData);
                
                new BTClient(s); /*Cliente Bluetooth que envía El mensaje del Cel*/
                

                
                
                System.out.println("Input:"+s);
                in.close();
                
                try { Hilo.sleep(100);} catch(InterruptedException e) {System.out.println("Error: "+e);};
                byte[] Data = {5,'H','E','L','L','O'};//primer numero length del payload
                
                OutputStream out = null;
                out = conn.openOutputStream();
                
                String DataOut = "ABCDEFG";
                
                //out.write(Data,0,Data.length);
                
                out.write(DataOut.length());
                out.write(DataOut.getBytes());
                out.flush();
                
                
                try { Hilo.sleep(10);} catch(InterruptedException e) {System.out.println("Error: "+e);};
                System.out.println("send!");
                out.close();
                try { Hilo.sleep(100);} catch(InterruptedException e) {System.out.println("Error: "+e);};
                conn.close();
            } catch (IOException e) {System.err.println("Error send1: " + e); continue;}
        }
    }
    
    public String getBTData (String s){ return s;}
}//end class